#include <Bounce2.h>

#define stepUpPin 4
#define stepDownPin 5
#define modeUpPin 14
#define modeDownPin 15

//für Encoder
#include <Encoder.h>
Encoder tuningEnc(2, 3);
//Encoder Ende

Bounce stepUpSwitch = Bounce();
Bounce stepDownSwitch = Bounce();
Bounce modeUpSwitch = Bounce();
Bounce modeDownSwitch = Bounce();
#define PRESSED 0
int e=0;
String voltemp = "";

void setup()
{
  Serial.begin(9600);
  pinMode(stepUpPin, INPUT);
  stepUpSwitch.attach( stepUpPin ); // attach to switch
  stepUpSwitch.interval(20); // 20ms settle time
  digitalWrite(stepUpPin, HIGH); // enable internal pull up
  pinMode(stepDownPin, INPUT);
  stepDownSwitch.attach( stepDownPin ); // attach to switch
  stepDownSwitch.interval(20); // 20ms settle time
  digitalWrite(stepDownPin, HIGH); // enable internal pull up
  //mode
  pinMode(modeUpPin, INPUT);
  modeUpSwitch.attach( modeUpPin ); // attach to switch
  modeUpSwitch.interval(20); // 20ms settle time
  digitalWrite(modeUpPin, HIGH); // enable internal pull up
  pinMode(modeDownPin, INPUT);
  modeDownSwitch.attach( modeDownPin ); // attach to switch
  modeDownSwitch.interval(20); // 20ms settle time
  digitalWrite(modeDownPin, HIGH); // enable internal pull up
  //mode

  //für Encoder
  tuningEnc.write(0);
  //Encoder ende

  Serial.println("ZZAG;");
  delay(200);
  String a = Serial.readStringUntil(";");
  e = int(a.substring(5, 7).toInt());
}

void loop()
{
  //Encoder
  long tunePosition = tuningEnc.read();
  //Encoder ende

  if (stepUpSwitch.update()) {
    if (stepUpSwitch.read() == PRESSED) {
      Serial.print("ZZBU;"); // Step the frequency UP
    }
  }
  if (stepDownSwitch.update()) {
    if (stepDownSwitch.read() == PRESSED) {
      Serial.print("ZZBD;"); // Step the frequency DOWN
    }
  }
  if (modeUpSwitch.update()) {
    if (modeUpSwitch.read() == PRESSED) {
      Serial.print("ZZSU;"); // Step the Step-frequency UP
    }
  }
  if (modeDownSwitch.update()) {
    if (modeDownSwitch.read() == PRESSED) {
      Serial.print("ZZSD;"); // Step the step-frequency DOWN
    }
  }
  
  // Encoder
  if (tunePosition > 0) {
    if(e<100) {
        e = e + 1;
        Serial.print("ZZAG"+voltemp+";");
      }
      tuningEnc.write(0);
  }
  if (tunePosition < 0) {
    if (e > 0) {
      e = e - 1;
      nuller(e);
      Serial.print("ZZAG"+voltemp+";");
     }
     tuningEnc.write(0);
  }  
}

void nuller(int zahl) {
  voltemp = "";
  if (zahl < 100) {
    voltemp = "0";
  }
  if (zahl < 10) {
    voltemp = voltemp + "0";
  }
  voltemp= voltemp + zahl;
}
